<?php

declare(strict_types=1);

namespace Drupal\flysystem;

use Drupal\Core\Cache\CacheBackendInterface;
use Drupal\Core\Extension\ModuleHandlerInterface;
use Drupal\Core\Plugin\DefaultPluginManager;
use Drupal\flysystem\Annotation\FlysystemAdapter;

/**
 * FlysystemAdapter plugin manager.
 */
final class FlysystemAdapterPluginManager extends DefaultPluginManager {

  /**
   * Constructs the object.
   */
  public function __construct(\Traversable $namespaces, CacheBackendInterface $cache_backend, ModuleHandlerInterface $module_handler) {
    parent::__construct('Plugin/FlysystemAdapter', $namespaces, $module_handler, FlysystemSubAdapterInterface::class, FlysystemAdapter::class);
    $this->alterInfo('flysystem_adapter_info');
    $this->setCacheBackend($cache_backend, 'flysystem_adapter_plugins');
  }

}
